; :collapseFolds=1:maxLineLen=80:mode=autoitscript:tabSize=8:indentSize=8:folding=indent:
;Global Const $__DEBUG__ = False ;#__DEBUG__
Opt("TrayIconHide", 1) ;0=show, 1=hide tray icon

#region Info
	#cs
V0.996:
	* Speicherverbrauch gesenkt (um bis zu 11MB)
	* Bei Up-Down in der Befehlsliste bleibt der entsprechende Eintrag nun markiert.
	* Fehlermeldung von "_FFFrameEnter ==> Socket error" in EXE behoben.
	* "Run" funktioniert nun auch bei kompliertem Script

V0.995:
	* Verschiedene Arten von Login-Scripten koennen nun erzeugt werden, inkl.
	einem Tepmplate (in der INI) zum Erzeugen einer Login-Funktion.

	Folgende Platzhalter werden durch die entsprechenden Funktionen ersetzt:
	%url    = Aufruf der URL (setzt @error)
	%name   = Setzen des Benutzernamens (return = eingabe)
	%pass   = Setzen des Passwortes (return = eingabe)
	%submit = Absenden des Formulares (setzt @error)
	|       = Zeilenumbruch

V0.994:
	* Funktion zum Erzeugen eines Login-Scriptes eingebaut

V0.993:
	* Befehle koennen nun sortiert werden und gestartet werden

V0.992:
	* Transparenz kann nun eingestellt werden
	* Bei Image-Links mit JavaScript als HREF wird nun auch die Bild-SRC angezeigt
	* Fehler beim Index mehrfach vorhandener Namen behoben
	* Fehler in URL-Anzeige im Fenstertitel behoben.
	* Mehrere Optimierungen in readForms, createCommand
	#ce
#endregion Info

#region Includes
;#include <Array.au3>
#include <ComboConstants.au3>
#include <EditConstants.au3>
#include <File.au3>
#include <FF.au3>
#include <GUIConstantsEx.au3>
#include <GuiComboBox.au3>
#include <GuiListBox.au3>
#include <GuiTreeView.au3>
#include <WindowsConstants.au3>
#endregion Includes

#region Global Vars
Global $sGUI_Title = "FF - Page Analyzer"
Global $sGUI_Version = "V0.996b"
Global $sTreeURL
Global $aTreeFrames[1]
Global $iURLTimer
Global $_sURL
Global $Socket = -1
Global $sTemplate_Function
; Transparency
Global $aMenu_ViewTrans[4][2]
	$aMenu_ViewTrans[0][1] = 255 ; 0%
	$aMenu_ViewTrans[1][1] = 230 ; 10%
	$aMenu_ViewTrans[2][1] = 204 ; 20%
	$aMenu_ViewTrans[3][1] = 179 ; 30%
#endregion Global Vars

#region GUI
;===============================================================================
Global $Win_Main = GUICreate($sGUI_Title, 388, 572, 250, 106, -1, $WS_EX_TOPMOST)
Global $Input_URL = GUICtrlCreateInput("http://", 8, 8, 260, 21, BitOR($ES_AUTOHSCROLL, $ES_READONLY))
Global $List_Frame = GUICtrlCreateCombo("top", 276, 8, 40, 25, BitOR($CBS_DROPDOWNLIST, $CBS_AUTOHSCROLL))
GUICtrlSetState(-1, $GUI_DISABLE)
GUICtrlSetTip(-1, "Frame")
Global $Button_Analyze = GUICtrlCreateButton("Analyze", 320, 6, 60, 25)

GUICtrlCreateGroup("", 8, 30, 370, 300)
Global $Tree_Forms = GUICtrlCreateTreeView(16, 42, 356, 280)
Global $Tree_Context = GUICtrlCreateContextMenu($Tree_Forms)
Global $Tree_Context1 = GUICtrlCreateMenuItem("Create Command", $Tree_Context)
GUICtrlCreateGroup("", -99, -99, 1, 1)

GUICtrlCreateGroup("Options:", 8, 336, 370, 70)
GUICtrlCreateLabel("Socket:", 16, 358, 41, 17)
Global $Input_Socket = GUICtrlCreateInput("$Socket", 64, 354, 89, 21)
Global $Select_UseIndex = GUICtrlCreateCheckbox("Use Index", 256, 354, 110, 21)
GUICtrlCreateLabel("Action:", 16, 382, 34, 17)
Global $List_SetGet = GUICtrlCreateCombo("Set Value", 64, 378, 90, 25, BitOR($CBS_DROPDOWNLIST, $CBS_AUTOHSCROLL))
GUICtrlSetData(-1, "Get Value|Check|Uncheck|Click Link|Click Element|Form Submit|Form Reset")
Global $Value_Combo = GUICtrlCreateCombo("$sValue", 160, 378, 89, 25, BitOR($CBS_DROPDOWNLIST, $CBS_AUTOHSCROLL))
GUICtrlSetData(-1, "Variable|Fixed")
Global $Input_Variable = GUICtrlCreateInput("$sValue", 256, 378, 116, 21)
GUICtrlCreateGroup("", -99, -99, 1, 1)

Global $List_Commands = GUICtrlCreateList("", 8, 412, 370, 82, BitOr($WS_VSCROLL, $WS_HSCROLL))
; -- List-Menu
Global $List_Context = GUICtrlCreateContextMenu($List_Commands)
Global $List_Context_Del = GUICtrlCreateMenuItem("Delete", $List_Context)
Global $List_Context_Reset = GUICtrlCreateMenuItem("Delete All", $List_Context)
GUICtrlCreateMenuItem("", $List_Context)
Global $List_Context_Copy = GUICtrlCreateMenuItem("Copy to Clipboard", $List_Context)
Global $List_Context_CopyAll = GUICtrlCreateMenuItem("Copy all to Clipboard", $List_Context)
GUICtrlCreateMenuItem("", $List_Context)
Global $List_FFStart = GUICtrlCreateMenuItem("Add _FFStart", $List_Context)
Global $List_FFQuit = GUICtrlCreateMenuItem("Add _FFQuit", $List_Context)
Global $List_FFConnect = GUICtrlCreateMenuItem("Add _FFConnect", $List_Context)
Global $List_FFDisConnect = GUICtrlCreateMenuItem("Add _FFDisConnect", $List_Context)
Global $List_FFOpenURL = GUICtrlCreateMenuItem("Add _FFOpenURL", $List_Context)
Global $List_FFFrameEnter = GUICtrlCreateMenuItem("Add _FFFrameEnter", $List_Context)
Global $List_FFFrameLeave = GUICtrlCreateMenuItem("Add _FFFrameLeave", $List_Context)
;---
Global $List_Up = GUICtrlCreateButton("Up", 8, 500, 60, 25)
Global $List_Down = GUICtrlCreateButton("Down", 72, 500, 60, 25)
Global $List_Run = GUICtrlCreateButton("Run", 285, 500, 100, 25)

; - Status
Global $Status = GUICtrlCreateInput("", 2, 528, 280, 21, BitOR($ES_AUTOHSCROLL, $ES_READONLY))
Global $Progress_1 = GUICtrlCreateProgress(285, 528, 100, 10)
Global $Progress_2 = GUICtrlCreateProgress(285, 540, 100, 10)
; --- Menu
; -------- Options
Global $Menu_Options = GUICtrlCreateMenu("Options")
Global $Menu_Options1 = GUICtrlCreateMenuItem("Append", $Menu_Options)
GUICtrlCreateMenuItem("", $Menu_Options)
Global $Menu_Options_GetForm = GUICtrlCreateMenuItem("Get Forms", $Menu_Options)
GUICtrlSetState(-1, $GUI_CHECKED)
Global $Menu_Options_Form = GUICtrlCreateMenu("Forms ...", $Menu_Options)
Global $Menu_Options_GetFormID = GUICtrlCreateMenuItem("IDs", $Menu_Options_Form)
GUICtrlCreateMenuItem("", $Menu_Options)
Global $Menu_Options_GetLinks = GUICtrlCreateMenuItem("Links", $Menu_Options)
Global $Menu_Options_Links = GUICtrlCreateMenu("Links ...", $Menu_Options)
Global $Menu_Options_GetLinksName = GUICtrlCreateMenuItem("NAME", $Menu_Options_Links)
Global $Menu_Options_GetLinksID = GUICtrlCreateMenuItem("IDs", $Menu_Options_Links)
Global $Menu_Options_GetLinksHASH = GUICtrlCreateMenuItem("HASH", $Menu_Options_Links)
Global $Menu_Options_GetLinksTARGET = GUICtrlCreateMenuItem("TARGET", $Menu_Options_Links)
GUICtrlCreateMenuItem("", $Menu_Options)
Global $Menu_Options_Copy = GUICtrlCreateMenuItem("Copy To Clipboard", $Menu_Options)
GUICtrlSetState(-1, $GUI_CHECKED)

; -------- View
If Not(@OSVersion = "WIN_NT" Or _
		@OSVersion = "WIN_ME" Or _
		@OSVersion = "WIN_98" Or _
		@OSVersion = "WIN_95") Then
	Global $Menu_View = GUICtrlCreateMenu("View")
	;Global $Menu_View_OnTop = GUICtrlCreateMenuItem("Always On Top",$Menu_View)
	Global $Menu_ViewTrans = GUICtrlCreateMenu("Transparency ...", $Menu_View)
	$aMenu_ViewTrans[0][0] = GUICtrlCreateMenuItem("Off", $Menu_ViewTrans, 0, 1)
	$aMenu_ViewTrans[1][0] = GUICtrlCreateMenuItem("10%", $Menu_ViewTrans, 1, 1)
	$aMenu_ViewTrans[2][0] = GUICtrlCreateMenuItem("20%", $Menu_ViewTrans, 2, 1)
	$aMenu_ViewTrans[3][0] = GUICtrlCreateMenuItem("30%", $Menu_ViewTrans, 3, 1)
EndIf
; -------- Tools
Global $Menu_Tools = GUICtrlCreateMenu("Tools")
Global $Menu_Tools_Login = GUICtrlCreateMenuItem("Create Login Commands ...", $Menu_Tools)
Global $Menu_Tools_Login_Script = GUICtrlCreateMenuItem("Create Login Script ...", $Menu_Tools)
Global $Menu_Tools_Login_Func = GUICtrlCreateMenuItem("Create Login Function ...", $Menu_Tools)
GUICtrlCreateMenuItem("", $Menu_Tools)
Global $Menu_Tools1 = GUICtrlCreateMenuItem("Reconnect", $Menu_Tools)
; -------- Help
Global $Menu_Help = GUICtrlCreateMenu("Help")
Global $Menu_Help1 = GUICtrlCreateMenuItem("About ...", $Menu_Help)

readINI(@scriptdir & "\FF-Page_Analyzer.ini")
GUISetState(@SW_SHOW)
#endregion GUI
;===============================================================================
getMsg()
Exit
;===============================================================================
Func getMsg()
	Local $tmp = "", $sFile

	While 1
		sleep(10)
		Switch GUIGetMsg()
			Case $GUI_EVENT_CLOSE
				writeINI(@scriptdir & "\FF-Page_Analyzer.ini")
				Exit
			Case $Button_Analyze
				Analyze(GUICtrlRead($List_Frame))
				_ReduceMemory()
			Case $Tree_Context1
				createCommand()
			Case $List_Context_Del
				_GUICtrlListBox_DeleteString($List_Commands, _GUICtrlListBox_GetCurSel($List_Commands))
			Case $List_Up
				$tmp = _GUICtrlListBox_GetCurSel($List_Commands)
				_GUICtrlListBox_SwapString($List_Commands, $tmp-1 , $tmp)
				_GUICtrlListBox_SetCurSel($List_Commands, $tmp-1)
			Case $List_Down
				$tmp = _GUICtrlListBox_GetCurSel($List_Commands)
				_GUICtrlListBox_SwapString($List_Commands, $tmp+1 , $tmp)
				_GUICtrlListBox_SetCurSel($List_Commands, $tmp+1)
			Case $List_Run
				GUICtrlSetData($Status, "Executing Script ...")
				$tmp = "#include <FF.au3>" & @crlf
				For $i = 0 To _GUICtrlListBox_GetCount($List_Commands) - 1
					$tmp &= _GUICtrlListBox_GetText($List_Commands, $i) & @CRLF
				Next
				$sFile = _TempFile()
				If FileWrite( $sFile, $tmp ) Then
					RunWait(@ProgramFilesDir & "\AutoIt3\AutoIt3.exe " & $sFile, @scriptdir)
					FileDelete ($sFile)
				EndIf
				GUICtrlSetData($Status, "")
				_ReduceMemory()
			Case $List_Context_Copy
				ClipPut( _GUICtrlListBox_GetText($List_Commands, _GUICtrlListBox_GetCurSel($List_Commands)))
			Case $List_Context_CopyAll
				copyAll2ClipBoard()
			Case $List_FFStart
				If __FFIsURL($_sURL) Then _GUICtrlListBox_InsertString($List_Commands, GUICtrlRead($Input_Socket) & ' = _FFStart("' & $_sURL & '", Default, 2)')
			Case $List_FFConnect
				_GUICtrlListBox_InsertString($List_Commands, GUICtrlRead($Input_Socket) & " = _FFConnect()")
			Case $List_FFOpenURL
				If __FFIsURL($_sURL) Then _GUICtrlListBox_InsertString($List_Commands, '_FFOpenURL(' & GUICtrlRead($Input_Socket) & ', "' & $_sURL & '")')
			Case $List_FFQuit
				_GUICtrlListBox_InsertString($List_Commands, "_FFQuit(" & GUICtrlRead($Input_Socket) & ")")
			Case $List_FFDisConnect
				_GUICtrlListBox_InsertString($List_Commands, "_FFDisConnect(" & GUICtrlRead($Input_Socket) & ")")
			Case $List_Context_Reset
				_GUICtrlListBox_ResetContent($List_Commands)
			Case $List_FFFrameEnter
				_GUICtrlListBox_InsertString($List_Commands, "_FFFrameEnter(" & GUICtrlRead($Input_Socket) & "," & GUICtrlRead($List_Frame) & ")")
			Case $List_FFFrameLeave
				_GUICtrlListBox_InsertString($List_Commands, "_FFFrameLeave(" & GUICtrlRead($Input_Socket) & ")")
			Case $List_SetGet
				OnChangeAction()
			Case $Value_Combo
				OnChangeValue()
			Case $Menu_Tools_Login
				createLogin(0)
			Case $Menu_Tools_Login_Script
				createLogin(1)
			Case $Menu_Tools_Login_Func
				createLogin(2)
			Case $Menu_Tools1
				reconnectFF()
				_ReduceMemory()
			Case $aMenu_ViewTrans[0][0]
				WinSetTrans($Win_Main, "", $aMenu_ViewTrans[0][1])
			Case $aMenu_ViewTrans[1][0]
				WinSetTrans($Win_Main, "", $aMenu_ViewTrans[1][1])
			Case $aMenu_ViewTrans[2][0]
				WinSetTrans($Win_Main, "", $aMenu_ViewTrans[2][1])
			Case $aMenu_ViewTrans[3][0]
				WinSetTrans($Win_Main, "", $aMenu_ViewTrans[3][1])
			Case $Menu_Options1
				Toggle($Menu_Options1)
			Case $Menu_Options_GetForm
				Toggle($Menu_Options_GetForm)
			Case $Menu_Options_GetLinks
				Toggle($Menu_Options_GetLinks)
			Case $Menu_Options_GetFormID
				Toggle($Menu_Options_GetFormID)
			Case $Menu_Options_Copy
				Toggle($Menu_Options_Copy)
			Case $Menu_Options_GetLinksName
				Toggle($Menu_Options_GetLinksName)
			Case $Menu_Options_GetLinksID
				Toggle($Menu_Options_GetLinksID)
			Case $Menu_Options_GetLinksHASH
				Toggle($Menu_Options_GetLinksHASH)
			Case $Menu_Options_GetLinksTARGET
				Toggle($Menu_Options_GetLinksTARGET)
			Case $Menu_Help1
				WinSetOnTop($Win_Main, "", 0)
				MsgBox(64+262144, "About ...", $sGUI_Title & @crlf & $sGUI_Version & ", by thorsten.willert@gmx.de")
				WinSetOnTop($Win_Main, "", 1)
		EndSwitch
	WEnd
EndFunc   ;==>getMsg
;===============================================================================
Func connect()
	If $Socket = -1 Then $Socket = _FFConnect(default, default, 2000)
	If Not IsChecked($Menu_Options1) Then _GUICtrlTreeView_DeleteAll($Tree_Forms)

	Local $sURL = _FFSetGet($Socket, ".location.href")
	If __FFIsURL($sURL) Then
		If StringLen($sURL) > 50 Then
			GUICtrlSetData($Input_URL, StringLeft($sURL, 50) & "...")
		Else
			GUICtrlSetData($Input_URL, $sURL)
		EndIf
		$_sURL = $sURL

		GUICtrlSetData($List_Frame, "|top")
		Local $iFrames = _FFGetLength($Socket, "frames")
		If $iFrames <> 0 Then
			For $i = 0 To $iFrames - 1
				GUICtrlSetData($List_Frame, $i, 0)
			Next
			GUICtrlSetState($List_Frame, $GUI_ENABLE)
		Else
			GUICtrlSetState($List_Frame, $GUI_DISABLE)
		EndIf
	Else
		Return 0
	EndIf

	Return 1
EndFunc   ;==>connect
;===============================================================================
Func Analyze($vFrame)
	AdlibDisable()

	GUICtrlSetState($Button_Analyze, $GUI_DISABLE)
	If $Socket > -1 Then _FFFrameEnter($Socket, $vFrame)
	If connect() Then
		_GUICtrlTreeView_BeginUpdate($Tree_Forms)

		$sTreeURL = GUICtrlCreateTreeViewItem($_sURL, $Tree_Forms)
		_GUICtrlTreeView_SetBold($Tree_Forms, $sTreeURL)

		Local $tmp = _FFFrameSelected($Socket)
		If $tmp <> '"top"' Then GUICtrlCreateTreeViewItem("FRAMES[" & $tmp & "] - NAME: " & _FFFrameSelected($Socket, "name"), $sTreeURL)
		GUICtrlCreateTreeViewItem("TITLE: " & _FFSetGet($Socket, ".title"), $sTreeURL)
		If IsChecked($Menu_Options_GetForm) Then readForms()
		If IsChecked($Menu_Options_GetLinks) Then readLinks()

		GUICtrlSetData($List_Frame, StringReplace($tmp, '"', ""))

		_GUICtrlTreeView_EndUpdate($Tree_Forms)
	Else
		GUICtrlSetData($Status, "ERROR: Can't open connection to FireFox")
	EndIf
	_FFFrameLeave($Socket)
	GUICtrlSetState($Button_Analyze, $GUI_ENABLE)

	AdlibEnable("_getURL", $iURLTimer)

	Return
EndFunc   ;==>Analyze
;===============================================================================
Func readForms()
	Local $iForms, $iFormsElements, $iOptions, $sValue, $iIndex = 0
	Local $sID, $sType, $sName
	Local $hOptions
	Local $aTreeItem[1]
	Local $aTreeElements[1]
	Local $vTmp

	$iForms = _FFGetLength($Socket, "forms")
	ReDim $aTreeItem[$iForms + 1]

	If $iForms > 0 Then

		For $i = 0 To $iForms - 1 ; Forms

			GUICtrlSetData($Progress_1, 100 / $iForms * ($i + 1))
			; forms[n].name
			$sName = _FFSetGet($Socket, ".forms[" & $i & "].name")
			$aTreeItem[$i] = GUICtrlCreateTreeViewItem("forms[" & $i & "] - NAME: " & $sName, $sTreeURL)
			_GUICtrlTreeView_SetBold($Tree_Forms, $aTreeItem[$i])

			If IsChecked($Menu_Options_GetFormID) Then
				; forms[n].id
				$sID = _FFSetGet($Socket, ".forms[" & $i & "].id")
				If $sID <> "" Then GUICtrlCreateTreeViewItem("ID: " & $sID, $aTreeItem[$i])
			EndIf

			; form[n].elements.length
			$iFormsElements = _FFSetGet($Socket, ".forms[" & $i & "].elements.length")

			If $iFormsElements > 0 Then
				ReDim $aTreeElements[$iFormsElements]

				For $j = 0 To $iFormsElements - 1 ; Elements
					GUICtrlSetData($Progress_2, 100 / $iFormsElements * ($j + 1))

					GUICtrlSetData($Status, "Analyzing forms[" & $i & "].elements[" & $j & "] from URL ...")

					$sType = _FFSetGet($Socket, ".forms[" & $i & "].elements[" & $j & "].type")

					; forms[n].elements[n].name
					$sName = _FFSetGet($Socket, ".forms[" & $i & "].elements[" & $j & "].name")

					$aTreeElements[$j] = GUICtrlCreateTreeViewItem("elements[" & $j & "] - NAME: " & $sName, $aTreeItem[$i])

					; forms[n].elements[n].NAME.length (e.g. RadioButtons)
					If StringLen($sName) > 0 And (StringInStr($sType, "radio") Or StringInStr($sType, "check")) Then
						; Filter fuer (beliebte) unzulaessige Zeichen in HTMl-Bezeichnern
						$sName = StringRegExpReplace($sName, "[\[\]\(\)]", "")

						$vTmp =  _FFSetGet($Socket, ".forms[" & $i & "]." & $sName & ".length", 500)
						If $vTmp > 0 Then
							GUICtrlCreateTreeViewItem("INDEX: " & $iIndex, $aTreeElements[$j])
							$iIndex += 1
						EndIf
						If $iIndex >= $vTmp Then $iIndex = 0
					EndIf

					; forms[n].elements[n].type
					GUICtrlCreateTreeViewItem("TYPE: " & $sType, $aTreeElements[$j])

					; forms[n].elements[n].id
					If IsChecked($Menu_Options_GetFormID) Then
						$sID = _FFSetGet($Socket, ".forms[" & $i & "].elements[" & $j & "].id")
						If $sID <> "" Then GUICtrlCreateTreeViewItem("ID: " & $sID, $aTreeElements[$j])
					EndIf

					; forms[n].elements[n].value
					$sValue = _FFSetGet($Socket, ".forms[" & $i & "].elements[" & $j & "].value", 500)
					GUICtrlCreateTreeViewItem("VALUE: " & $sValue, $aTreeElements[$j])

					; forms[n].elements[n].checked
					If StringInStr($sType, "radio") Or StringInStr($sType, "check") Then
						GUICtrlCreateTreeViewItem("CHECKED: " & _FFSetGet($Socket, ".forms[" & $i & "].elements[" & $j & "].checked"), $aTreeElements[$j])
					EndIf

					If StringInStr($sType, "select") Then
						; forms[n].elements[n].selectedIndex
						GUICtrlCreateTreeViewItem("SELECTED INDEX: " & _FFSetGet($Socket, ".forms[" & $i & "].elements[" & $j & "].selectedIndex"), $aTreeElements[$j])

						; forms[n].elements[n].options.length
						$iOptions = _FFSetGet($Socket, ".forms[" & $i & "].elements[" & $j & "].options.length")
						$hOptions = GUICtrlCreateTreeViewItem("options:", $aTreeElements[$j])

						If $iOptions > 0 Then
							For $k = 0 To $iOptions - 1 ; Options
								; forms[n].elements[n].options[n].value
								GUICtrlCreateTreeViewItem("options[" & $k & "] - VALUE: " & _FFSetGet($Socket, ".forms[" & $i & "].elements[" & $j & "].options[" & $k & "].value"), $hOptions)
							Next ; Options
						EndIf
					EndIf ; StringInStr($sType, "select")

				Next ; Elements
			EndIf ; iElements > 0
		Next ; Forms
		GUICtrlSetData($Status, "")
	Else ; $iForms > 0
		GUICtrlSetData($Status, "No forms found!")
		_FFAction($Socket, "resetconsole")
	EndIf ; $iForms > 0

	GUICtrlSetData($Progress_1, 0)
	GUICtrlSetData($Progress_2, 0)
	Return
EndFunc   ;==>readForms
;===============================================================================
Func readLinks()
	Local $sTmp
	Local $iLinks
	Local $aTreeLinks[1]
	Local $sInfo, $aInfo, $aRegEx

	$iLinks = _FFGetLength($Socket, "links")
	ReDim $aTreeLinks[$iLinks + 1]

	If $iLinks > 0 Then
		For $i = 0 To $iLinks - 1 ; Links
			GUICtrlSetData($Progress_1, 100 / $iLinks * ($i + 1))
			GUICtrlSetData($Status, "Analyzing links[" & $i & "] from URL ...")

			$sInfo = _FFSetGet($Socket, 'FF_AutoItScript.GetLinkInfo(' & $i & ',' & _FFFrameSelected($Socket) & ')')
			$aInfo = StringSplit($sInfo, "|")

			If @ERROR Or UBound($aInfo) < 7 Then ContinueLoop

			If StringInStr($aInfo[7], "<img ") > 0 Then
				$aRegEx = StringRegExp($aInfo[7], '<img[ ]+(.*?)alt[ ]*=[ ]*\"(.*?)\"', 1)

				If IsArray($aRegEx) Then $aTreeLinks[$i] = GUICtrlCreateTreeViewItem("links[" & $i & "] - IMAGE: " & $aRegEx[1], $sTreeURL)
			Else
				$aTreeLinks[$i] = GUICtrlCreateTreeViewItem("links[" & $i & "] - TEXT: " & $aInfo[6], $sTreeURL)
			EndIf

			_GUICtrlTreeView_SetBold($Tree_Forms, $aTreeLinks[$i])

			Select
				Case StringInStr($aInfo[1], "javascript:") > 0
					GUICtrlCreateTreeViewItem("TYPE: javascript", $aTreeLinks[$i])
					$aRegEx = StringRegExp($aInfo[7], '<img[ ]+(.*?)src[ ]*=[ ]*\"(.*?)\"', 1)
					If Not @ERROR Then GUICtrlCreateTreeViewItem("IMAGE: " & $aRegEx[1], $aTreeLinks[$i])
				Case StringInStr($aInfo[7], "<img ") > 0
					GUICtrlCreateTreeViewItem("TYPE: imglink", $aTreeLinks[$i])
					$aRegEx = StringRegExp($aInfo[7], '<img[ ]+(.*?)src[ ]*=[ ]*\"(.*?)\"', 1)
					GUICtrlCreateTreeViewItem("IMAGE: " & $aRegEx[1], $aTreeLinks[$i])
				Case Else
					GUICtrlCreateTreeViewItem("TYPE: link", $aTreeLinks[$i])
			EndSelect

			GUICtrlCreateTreeViewItem("HREF: " & $aInfo[1], $aTreeLinks[$i])

			If IsChecked($Menu_Options_GetLinksHASH) Then
				If $aInfo[2] <> "" Then GUICtrlCreateTreeViewItem("HASH: " & $aInfo[2], $aTreeLinks[$i])
			EndIf

			If IsChecked($Menu_Options_GetLinksName) Then
				If $aInfo[4] <> "" Then GUICtrlCreateTreeViewItem("NAME: " & $aInfo[4], $aTreeLinks[$i])
			EndIf

			If IsChecked($Menu_Options_GetLinksID) Then
				If $aInfo[5] <> "" Then GUICtrlCreateTreeViewItem("ID: " & $aInfo[5], $aTreeLinks[$i])
			EndIf

			GUICtrlSetData($Progress_2, 100)
			If IsChecked($Menu_Options_GetLinksTARGET) Then
				$sTmp = _FFSetGet($Socket, ".target[" & $i & "].target")
				If $sTmp <> "" Then GUICtrlCreateTreeViewItem("TARGET: " & $sTmp, $aTreeLinks[$i])
			EndIf
		Next

		GUICtrlSetData($Status, "")
	Else ; $iLinks > 0
		GUICtrlSetData($Status, "No links found!")
		_FFAction($Socket, "resetconsole")
	EndIf ; $iLinks > 0

	GUICtrlSetData($Progress_1, 0)
	GUICtrlSetData($Progress_2, 0)
	Return

EndFunc   ;==>readLinks
;===============================================================================
Func createCommand()
	AdlibDisable()

	Local $hCurrent = _GUICtrlTreeView_GetSelection($Tree_Forms)
	Local $sItem = _GUICtrlTreeView_GetText($Tree_Forms, $hCurrent)

	If StringInStr($sItem, "elements[") = 0 And StringInStr($sItem, "links[") = 0 Then
		GUICtrlSetData($Status, 'Select "elements[n]" or "links[n] ...')
		Return
	EndIf
	GUICtrlSetData($Status, "")

	Local $sTmp
	Local $sCommand
	; NAME, INDEX
	$sItem = _GUICtrlTreeView_GetTree($Tree_Forms, 0)
	Local $aArray = StringSplit($sItem, "|")
	Local $sForm = StringLeft($aArray[1], StringInStr($aArray[1], "]"))
	Local $sFormName = StringMid($aArray[1], StringInStr($aArray[1], "NAME:") + 6)
	Local $sElements = StringLeft($aArray[2], StringInStr($aArray[2], "]"))
	Local $sElementsName = StringMid($aArray[2], StringInStr($aArray[2], "NAME:") + 6)

	; LINK INDEX
	Local $iLink = StringLeft($aArray[2], StringInStr($aArray[2], "]"))

	; TYPE
	Local $hType = _GUICtrlTreeView_FindItem($Tree_Forms, "TYPE:", true, $hCurrent)
	Local $sType = _GUICtrlTreeView_GetText($Tree_Forms, $hType)
	$sType = StringMid($sType, StringInStr($sType, ":") + 2)

	; INDEX
	Local $bIndex = BitAnd( GUICtrlRead($Select_UseIndex), $GUI_CHECKED)
	$hType = _GUICtrlTreeView_FindItem($Tree_Forms, "INDEX:", true, $hCurrent)
	If $hType <> 0 Then
		Local $sIndex = _GUICtrlTreeView_GetText($Tree_Forms, $hType)
		$sIndex = StringRegExpReplace($sIndex, "(\[|\]|INDEX:|-| )", "")
	Else
		$sIndex = 0
	EndIf

	; HREF
	$hType = _GUICtrlTreeView_FindItem($Tree_Forms, "HREF:", true, $hCurrent)
	If $hType <> 0 Then
		Local $sHREF = _GUICtrlTreeView_GetText($Tree_Forms, $hType)
		$sHREF = StringMid($sHREF, StringInStr($sHREF, ":") + 2)
	Else
		$sHREF = ""
	EndIf

	; Variable
	$sTmp = GUICtrlRead($Input_Variable)
	Local $sVariable
	Local $aVariable[2] = [ '"%1"', chr(34) & "' & %1 & '" & chr(34)]
	; --- check $x
	If GUICtrlRead($Value_Combo) = "Variable" Then
		If StringLeft($sTmp, 1) <> "$" Then
			$sTmp = "$" & $sTmp
			If StringLen($sTmp) = 1 Then $sTmp = "$sValue"
			GUICtrlSetData($Input_Variable, $sTmp)
		EndIf
	EndIf
	Select
		Case GUICtrlRead($List_SetGet) = "Set Value" And GUICtrlRead($Value_Combo) <> "Fixed"
			Switch $bIndex
				Case false
					$sVariable = $sTmp
				Case true
					$sVariable = $aVariable[1]
			EndSwitch
		Case GUICtrlRead($List_SetGet) = "Set Value"
			$sVariable = $aVariable[0]
		Case GUICtrlRead($List_SetGet) = "Get Value"
			If $sTmp = "" Then
				$sVariable = "$sValue"
			Else
				$sVariable = $sTmp
			EndIf
	EndSelect
	$sVariable = StringReplace($sVariable, "%1", $sTmp)

	Switch StringLower(GUICtrlRead($List_SetGet))
		Case "get value" ; text, password, checkbox, radio and hidden
			If $sType = "text" Or $sType = "password" Or $sType = "hidden" Or $sType = "checkbox" OR $sType = "radio" Then
				If Not $bIndex And $sElementsName <> "" Then
					$sCommand = StringFormat('%s = _FFGetValueByName($Socket, "%s", %s)', $sVariable, $sElementsName, $sIndex)
				Else
					$sCommand = StringFormat("%s = _FFSetGet($Socket, '.%s.%s.value')", $sVariable, $sForm, $sElements)
				EndIf
			EndIf
		Case "set value" ; text, password and hidden
			If $sType = "text" Or $sType = "password" Or $sType = "hidden" Then
				If Not $bIndex And $sElementsName <> "" Then
					If $sVariable <> '""' Then
						$sCommand = StringFormat('_FFSetValueByName($Socket, "%s", %s)', $sElementsName, $sVariable)
					Else
						$sCommand = '_FFSetValueByName($Socket, "' & $sElementsName & '")'
					EndIf
				Else
					$sCommand = StringFormat("_FFSetGet($Socket, '.%s.%s.value=%s')", $sForm, $sElements, $sVariable)
				EndIf
			EndIf
		Case "check" ; radio and checkbox
			If $sType = "checkbox" Then
				If Not $bIndex And $sElementsName <> "" And $sFormName <> "" And $sIndex > -1 Then
					$sCommand = StringFormat('_FFFormCheckBox($Socket, "%s", true, %s, "name", "%s", "name")',$sElementsName, $sIndex, $sFormName)
				Else
					$sCommand = StringFormat("_FFSetGet($Socket, '.%s.%s.checked=true')", $sForm, $sElements)
				EndIf
			ElseIf $sType = "radio" Then
				If Not $bIndex And $sElementsName <> "" And $sFormName <> "" And $sIndex > -1 Then
					$sCommand = StringFormat('_FFFormRadioButton($Socket, "%s", %s, "name", "%s", "name")',$sElementsName, $sIndex, $sFormName)
				Else
					$sCommand = StringFormat("_FFSetGet($Socket, '.%s.%s.checked=true')", $sForm, $sElements)
				EndIf
			EndIf
		Case "uncheck" ; checkbox
			If $sType = "checkbox" Then
				If Not $bIndex And $sElementsName <> "" And $sFormName <> "" And $sIndex > -1 Then
					$sCommand = StringFormat('_FFFormCheckBox($Socket, "%s", true, %s, "name", "%s", "name")',$sElementsName, $sIndex, $sFormName)
				Else
					$sCommand = StringFormat("_FFSetGet($Socket, '.%s.%s.checked=false')", $sForm, $sElements)
				EndIf
			EndIf
		Case "click link" ; link
			If Not $bIndex And($sType = "link" Or $sType = "imglink") And StringInStr($sHREF, "javascript:") = 0 Then
				$sCommand = StringFormat("_FFClickLink($Socket, '%s')",$sHREF)
			Else
				$sCommand = StringFormat("_FFClick($Socket, '.%s')",$iLink)
			EndIf
		Case "click element" ; all elements
			If $sType <> "link" And $sType <> "imglink" And $sType <> "javascript" Then
				If Not $bIndex And $sFormName <> "" And $sElementsName <> "" Then
					$sCommand = StringFormat("_FFClick($Socket,'.%s.%s')", $sFormName, $sElementsName)
				Else
					$sCommand = StringFormat("_FFClick($Socket,'.%s.%s')", $sForm, $sElements)
				EndIf
			EndIf
		Case "form submit" ; all elements
			If Not $bIndex And $sFormName <> "" Then
				$sCommand = StringFormat('_FFFormSubmit($Socket,"%s","name")', $sFormName)
			Else
				$sCommand = '_FFFormSubmit($Socket, %1)'
				$sCommand = StringReplace($sCommand, "%1", _
						StringMid($sForm, StringInStr($sForm, "[") + 1, 1) _
						)
			EndIf
		Case "form reset" ; all elements
			If Not $bIndex And $sFormName <> "" Then
				$sCommand = StringFormat('_FFFormReset($Socket,"%s","name")', $sFormName)
			Else
				$sCommand = '_FFFormReset($Socket, %1)'
				$sCommand = StringReplace($sCommand, "%1", _
						StringMid($sForm, StringInStr($sForm, "[") + 1, 1) _
						)
			EndIf
	EndSwitch

	Local $sInputSocket = StringStripWS(GUICtrlRead($Input_Socket), 3)
	If $sInputSocket <> "$Socket" And StringLeft($sInputSocket, 1) = "$" And StringLen($sInputSocket) > 1 Then $sCommand = StringReplace($sCommand, "$Socket", $sInputSocket)
	If IsChecked($Menu_Options_Copy) Then ClipPut($sCommand)

	If $sCommand <> "" Then GUICtrlSetData($List_Commands, $sCommand & "|")

	AdlibEnable("_getURL", $iURLTimer)
	Return
EndFunc   ;==>createCommand
;===============================================================================
Func createLogin($iMode)
	Local $sCommand = "", $iForm = -1, $iPassName, $iPassWord

	Local $aCommand[6]
	$aCommand[0] = '_FFSetValueByName($Socket,"%s",%s)'
	$aCommand[1] = '_FFSetValueByName($Socket,"%s",%s)'
	$aCommand[2] = '_FFFormSubmit($Socket,"%s","name")'

	$aCommand[3] = '_FFSetGet($Socket,".forms[%s].elements[%s].value=%s")'
	$aCommand[4] = '_FFSetGet($Socket,".forms[%s].elements[%s].value=%s")'
	$aCommand[5] = '_FFFormSubmit($Socket,%s)'

	Local $hURL = _GUICtrlTreeView_GetSelection($Tree_Forms)
	Local $sItem = _GUICtrlTreeView_GetText($Tree_Forms, $hURL)
	If $hURL = 0 Then Return 0
	If StringInStr($sItem, "http") = 0 Then
		$hURL = _GUICtrlTreeView_FindItem($Tree_Forms, "http",true)
		If $hURL = 0 Then Return 0
	EndIf

	; searching a password-input
	Local $hPass = _GUICtrlTreeView_FindItem($Tree_Forms, "TYPE: password",false,$hURL)
	If Not $hPass Then
		GUICtrlSetData($Status, "Can't find input-type: password")
		Return 0
	EndIf
	Local $hPassword = _GUICtrlTreeView_GetParentHandle($Tree_Forms, $hPass)
	Local $sPassword = _GUICtrlTreeView_GetText($Tree_Forms, $hPassword)

	; getting the form for the password-input
	Local $hForm = _GUICtrlTreeView_GetParentHandle($Tree_Forms, $hPassword)
	Local $sForm = _GUICtrlTreeView_GetText($Tree_Forms, $hForm)

	; and searching in this form a text-input
	Local $hName = _GUICtrlTreeView_FindItem($Tree_Forms, "TYPE: text",false,$hForm)
	Local $hPassName = _GUICtrlTreeView_GetParentHandle($Tree_Forms, $hName)
	Local $sPassName = _GUICtrlTreeView_GetText($Tree_Forms, $hPassName)

	Local $aArray = StringRegExp($sForm,"forms\[(\d+)\]",1)
	If Not @error Then $iForm = $aArray[0]
	If $iForm = -1 Then Return 0
	$sForm = StringMid($sForm,StringInStr($sForm,":")+2)

	$aArray = StringRegExp($sPassName,"elements\[(\d+)\]",1)
	If Not @error Then $iPassName = $aArray[0]
	$sPassName = StringMid($sPassName,StringInStr($sPassName,":")+2)

	$aArray = StringRegExp($sPassword,"elements\[(\d+)\]",1)
	If Not @error Then $iPassword = $aArray[0]
	$sPassword = StringMid($sPassword,StringInStr($sPassword,":")+2)

	If ($sForm <> "") And ($sPassName <> "") And ($sPassWord <> "") Then
		$aCommand[0] = StringFormat($aCommand[0],$sPassName,"$sUserName")
		$aCommand[1] = StringFormat($aCommand[1],$sPassWord,"$sPassWord")
		$aCommand[2] = StringFormat($aCommand[2],$sForm)
	ElseIf $iForm >= 0 Then
		$aCommand[0] = StringFormat($aCommand[3],$iForm,$iPassName,"'" & '" & $sUserName & "' & "'")
		$aCommand[1] = StringFormat($aCommand[4],$iForm,$iPassWord,"'" & '" & $sPassWord & "' & "'")
		$aCommand[2] = StringFormat($aCommand[5],$iForm)
	Else
		Return 0
	EndIf

	Switch $iMode
		Case 0
			$sCommand = $aCommand[0] & "|" & $aCommand[1] & "|" & $aCommand[2]
		Case 1
			$sCommand = $aCommand[0] & "|" & $aCommand[1] & "|" & $aCommand[2]
			$sCommand = '$sUserName = ""|$sPassWord = ""|$Socket = _FFConnect()|If $Socket > -1 Then|_FFOpenURL($Socket, "' & _FFSetGet($Socket,".location.href") &'")|' & $sCommand & "|EndIf"
		Case 2
			$sCommand = StringReplace($sTemplate_Function,"%name",$aCommand[0])
			$sCommand = StringReplace($sCommand,"%pass",$aCommand[1])
			$sCommand = StringReplace($sCommand,"%submit",$aCommand[2])
			$sCommand = StringReplace($sCommand,"%url",'_FFOpenURL($Socket, "' & _FFSetGet($Socket,".location.href") &'")')
	EndSwitch


	Local $sInputSocket = StringStripWS(GUICtrlRead($Input_Socket), 3)
	If $sInputSocket <> "$Socket" And StringLeft($sInputSocket, 1) = "$" And StringLen($sInputSocket) > 1 Then $sCommand = StringReplace($sCommand, "$Socket", $sInputSocket)

	If $sCommand <> "" Then GUICtrlSetData($List_Commands, $sCommand)

	If IsChecked($Menu_Options_Copy) Then copyAll2ClipBoard()

	Return 1

EndFunc  ;==>createLogin
;===============================================================================
Func OnChangeValue()
	Switch StringLower(GUICtrlRead($Value_Combo))
		Case "$svalue"
			GUICtrlSetState($Input_Variable, $GUI_DISABLE)
			GUICtrlSetData($Input_Variable, "$sValue")
		Case "variable"
			GUICtrlSetState($Input_Variable, $GUI_ENABLE)
			GUICtrlSetData($Input_Variable, "")
		Case "fixed"
			If GUICtrlRead($List_SetGet) = "Get Value" Then
				GUICtrlSetState($Input_Variable, $GUI_DISABLE)
			Else
				GUICtrlSetState($Input_Variable, $GUI_ENABLE)
			EndIf
			GUICtrlSetData($Input_Variable, "")
	EndSwitch

	Return
EndFunc   ;==>OnChangeValue
;===============================================================================
Func OnChangeAction()
	;"Set Value|Get Value|Check|Uncheck|Click Link|Click Element|Form Submit|Form Reset"

	Switch StringLower(GUICtrlRead($List_SetGet))
		Case "set value"
			GUICtrlSetState($Value_Combo, $GUI_ENABLE)
			If GUICtrlRead($Value_Combo) <> "$sValue" Then GUICtrlSetState($Input_Variable, $GUI_ENABLE)
		Case "get value"
			GUICtrlSetState($Value_Combo, $GUI_ENABLE)
			If GUICtrlRead($Value_Combo) = "Fixed" Then GUICtrlSetState($Input_Variable, $GUI_DISABLE)
		Case Else
			GUICtrlSetState($Input_Variable, $GUI_DISABLE)
			GUICtrlSetState($Value_Combo, $GUI_DISABLE)
	EndSwitch

	Return
EndFunc   ;==>OnChangeAction
;===============================================================================
Func _getURL()
	Local $sURL = _FFSetGet($Socket, ".location.href", 1000)
	Local $aURL = StringRegExp($sURL, "://(.*?)/",1)
	If __FFIsURL($sURL) And IsArray($aURL) Then
		WinSetTitle($Win_Main, "", $aURL[0] & " - " & $sGUI_Title)
		$_sURL = $sURL
		GUICtrlSetTip($Input_URL, $sURL)

		If IsLoaded() Then
			GUICtrlSetState($Button_Analyze, $GUI_ENABLE)
		Else
			GUICtrlSetState($Button_Analyze, $GUI_DISABLE)
		EndIf
	Else
		GUICtrlSetState($Button_Analyze, $GUI_ENABLE)
	EndIf
	GUICtrlSetData($Status, "")
EndFunc   ;==>_getURL
;===============================================================================
Func Toggle($item)
	If IsChecked($item) Then
		GUICtrlSetState($item, $GUI_UNCHECKED)
		Return false
	Else
		GUICtrlSetState($item, $GUI_CHECKED)
		Return true
	EndIf
EndFunc   ;==>Toggle
;===============================================================================
Func IsChecked($id)
	Return BitAnd(GUICtrlRead($id), $GUI_CHECKED)
EndFunc   ;==>IsChecked
;===============================================================================
Func IsLoaded()
	Local $tmp = _FFSetGet($Socket, "document.getElementById('statusbar-icon').value")
	If @error Then Return 0
	If $tmp >= 95 Then Return 1
	Return 0
EndFunc   ;==>IsLoaded
;===============================================================================
Func reconnectFF()
	AdlibDisable()
	_FFDisConnect($Socket)
	GUICtrlSetData($Status, "Connecting to FireFox ...")
	Sleep(100)
	$Socket = _FFConnect()
	If $Socket = -1 Then
		GUICtrlSetData($Status, "ERROR: Can't open connection to FireFox")
		Return
	Else
		GUICtrlSetData($Status, "")
		AdlibEnable("_getURL", $iURLTimer)
		Return
	EndIf
EndFunc   ;==>reconnectFF
;===============================================================================
Func TreeSearchItem($sItem)
	If _GUICtrlTreeView_FindItem($Tree_Forms, $sItem) <> 0 Then Return 1
	Return 0
EndFunc   ;==>TreeSearchItem
;===============================================================================
Func copyAll2ClipBoard()
	Local $tmp = ""
	For $i = 0 To _GUICtrlListBox_GetCount($List_Commands) - 1
		$tmp &= _GUICtrlListBox_GetText($List_Commands, $i) & @CRLF
	Next
	ClipPut($tmp)

	_ReduceMemory()

	Return
EndFunc
;===============================================================================
Func writeINI($sINI)
	IniWriteSection($sINI, "misc", "URLTimer=" & $iURLTimer)

	Local $i
	For $i = 0 To Ubound($aMenu_ViewTrans)-1
		If IsChecked($aMenu_ViewTrans[$i][0]) Then ExitLoop
	Next

	Local $aData[10][2] = [["Append", IsChecked($Menu_Options1)], _
			["Transparency", $i ], _
			["GetForm", IsChecked($Menu_Options_GetForm)], _
			["GetFormID", IsChecked($Menu_Options_GetFormID)], _
			["GetLinks", IsChecked($Menu_Options_GetLinks)], _
			["GetLinksName", IsChecked($Menu_Options_GetLinksName)], _
			["GetLinksID", IsChecked($Menu_Options_GetLinksID)], _
			["GetLinksHASH", IsChecked($Menu_Options_GetLinksHASH)], _
			["GetLinksTarget", IsChecked($Menu_Options_GetLinksTARGET)], _
			["CopyToClipboard", IsChecked($Menu_Options_Copy)]]
	IniWriteSection($sINI, "options", $aData, 0)

	Local $aData2[5][2] = [["UseIndex", IsChecked($Select_UseIndex)], _
			["Socket", GUICtrlRead($Input_Socket)], _
			["Action", _GUICtrlComboBox_GetCurSel($List_SetGet)], _
			["Value", _GUICtrlComboBox_GetCurSel($Value_Combo)], _
			["Variable", GUICtrlRead($Input_Variable)]]
	IniWriteSection($sINI, "command_options", $aData2, 0)

	IniWriteSection($sINI, "templates", "Function=" & $sTemplate_Function)
EndFunc   ;==>writeINI
;===============================================================================
Func readINI($sINI)
	$iURLTimer = IniRead($sINI, "misc", "URLTimer", 5000)
	If $iURLTimer < 1000 Then $iURLTimer = 5000

	Local $tmp = IniRead($sINI, "options", "Transparency", 0)
	GUICtrlSetState($aMenu_ViewTrans[$tmp][0], $GUI_CHECKED)
	WinSetTrans($Win_Main, "", $aMenu_ViewTrans[$tmp][1])

	GUICtrlSetState($Menu_Options1, IniRead($sINI, "options", "Append", 0))
	GUICtrlSetState($Menu_Options_GetForm, IniRead($sINI, "options", "GetForm", 1))
	GUICtrlSetState($Menu_Options_GetFormID, IniRead($sINI, "options", "GetFormID", 0))
	GUICtrlSetState($Menu_Options_GetLinks, IniRead($sINI, "options", "GetLinks", 1))
	GUICtrlSetState($Menu_Options_GetLinksName, IniRead($sINI, "options", "GetLinksName", 0))
	GUICtrlSetState($Menu_Options_GetLinksID, IniRead($sINI, "options", "GetLinksID", 0))
	GUICtrlSetState($Menu_Options_GetLinksHASH, IniRead($sINI, "options", "GetLinksHASH", 0))
	GUICtrlSetState($Menu_Options_GetLinksTARGET, IniRead($sINI, "options", "GetLinksTarget", 0))
	GUICtrlSetState($Menu_Options_Copy, IniRead($sINI, "options", "CopyToClipboard", 1))
	GUICtrlSetState($Select_UseIndex, IniRead($sINI, "command_options", "UseIndex", 0))
	GUICtrlSetData($Input_Socket, IniRead($sINI, "command_options", "Socket", "$Socket"))
	_GUICtrlComboBox_SetCurSel($List_SetGet, IniRead($sINI, "command_options", "Action", 0))
	_GUICtrlComboBox_SetCurSel($Value_Combo, IniRead($sINI, "command_options", "Value", 0))
	GUICtrlSetData($Input_Variable, IniRead($sINI, "command_options", "Variable", ""))

	$sTemplate_Function = IniRead($sINI,"templates","Function",'')
	If $sTemplate_Function = '' Then $sTemplate_Function = 'Func _FFLogin(ByRef $Socket, $sUserName, $sPassWord, $sSuccses)|If $Socket > -1 Then|%url|If @error Then Return 0|If %name <> $sUserName Then Return 0|If %pass <> $sPassWord Then Return 0|%submit|If @error Then Return 0|_FFLoadWait($Socket)|If _FFAction($Socket,"search",$sSuccses) Then Return 1|EndIf|Return 0|EndFunc'

	OnChangeAction()
	OnChangeValue()
EndFunc   ;==>readINI
;===============================================================================
Func _ReduceMemory($i_PID = -1)
	If $i_PID <> -1 Then
		Local $ai_Handle = DllCall("kernel32.dll", 'int', 'OpenProcess', 'int', 0x1f0fff, 'int', False, 'int', $i_PID)
		Local $ai_Return = DllCall("psapi.dll", 'int', 'EmptyWorkingSet', 'long', $ai_Handle[0])
		DllCall('kernel32.dll', 'int', 'CloseHandle', 'int', $ai_Handle[0])
	Else
		Local $ai_Return = DllCall("psapi.dll", 'int', 'EmptyWorkingSet', 'long', -1)
	EndIf

	Return $ai_Return[0]
EndFunc   ;==>_ReduceMemory